<script setup lang="ts">
import type { BaseLink, BaseImage } from '@/types/base';
import { Blog, Report, Ebook, Video, ChevronLgRight, Announcement, Money } from 'slippers-ui/icons';
import { ref } from 'vue';

type CardProps = {
  header: string;
  type: string;
  link: BaseLink;
  image: BaseImage;
};

const props = defineProps<CardProps>();

const icons: Component = {
  Blog,
  Report,
  Ebook,
  Video,
  Announcement,
  Money,
};

const modalOpen = ref(false);
const openModal = (e: Event) => {
  if (props.link.config.modal) {
    e.preventDefault();
    modalOpen.value = true;
  }
};

const closeModal = () => {
  modalOpen.value = false;
};
</script>

<template>
  <div>
    <a
      class="resources-card"
      :href="link.config.href"
      :data-ga-name="link.config.dataGaName"
      :data-ga-location="link.config.dataGaLocation"
      @click="openModal($event)"
    >
      <div>
        <SlpIcon v-if="link.config.icon" :icon="icons[link.config.icon]" size="sm" class="slp-mr-8" />
        <SlpTypography tag="span" variant="body2" class="slp-mb-16">{{ type }}</SlpTypography>
      </div>
      <div class="resources-card__img">
        <img :src="image.config.src" :alt="image.altText" loading="lazy" />
      </div>
      <div>
        <SlpTypography tag="h3" variant="body1" class="slp-mb-16">{{ header }}</SlpTypography>
      </div>
      <div v-if="link.text" class="resources-card__cta">
        <SlpTypography tag="span" variant="body2-bold">{{ link.text }}</SlpTypography>

        <SlpIcon :icon="ChevronLgRight" size="sm" />
      </div>
    </a>
    <CommonVideoModal v-if="link.config.modal" :visible="modalOpen" @close="closeModal">
      <template #body>
        <CommonVideo :video-src="link.config.href" class="video"> </CommonVideo>
      </template>
    </CommonVideoModal>
  </div>
</template>

<style lang="scss" scoped>
.resources-card {
  cursor: pointer;
  display: flex;
  position: relative;
  height: 100%;
  min-width: 300px;
  flex-direction: column;
  padding: 32px 16px;
  background-color: #fff;
  color: $color-text-300;
  transition: all 0.3s ease-in-out;
  gap: 24px;
  @media (min-width: $breakpoint-md) {
    margin: $spacing-16 $spacing-16 $spacing-16 0;
  }

  &__cta {
    display: flex;
    align-items: center;
  }

  &__cta .slp-icon {
    margin-left: 4px;
    transition: all 0.3s ease;
  }

  &:hover,
  &:focus {
    background: $color-surface-800;
    border-radius: 4px 4px 96px 4px;
    .resources-card__cta .slp-icon {
      margin-left: 8px;
    }
  }

  &__img {
    width: 100%;
    img {
      height: 100%;
      width: 100%;
      object-fit: cover;
    }
  }
  .resources-tabs--dark & {
    color: #fff;
    background-color: transparent;
    &:hover,
    &:focus {
      background: #ffffff0d;
    }
  }
}
</style>
